Index: cpukit/rtems/src/dpmem.c
===================================================================
--- cpukit/rtems/src/dpmem.c	(revision 17f744b8c81be98f68d53a82583c9a0b1c690579)
+++ cpukit/rtems/src/dpmem.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -1,48 +1,268 @@
-/**
- * @file
- *
- * @ingroup RTEMSImplClassicDPMem
- *
- * @brief This source file contains a definition of
- *   ::_Dual_ported_memory_Information with zero objects.
- */
-
 /*
- * SPDX-License-Identifier: BSD-2-Clause
- *
- * Copyright (C) 2018 embedded brains GmbH & Co. KG
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
-
-#ifdef HAVE_CONFIG_H
-#include "config.h"
-#endif
-
-#include <rtems/rtems/dpmemdata.h>
-
-OBJECTS_INFORMATION_DEFINE_ZERO(
-  _Dual_ported_memory,
-  OBJECTS_CLASSIC_API,
-  OBJECTS_RTEMS_PORTS,
-  OBJECTS_NO_STRING_NAME
-);
+ *  Dual Port Memory Manager
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/address.h>
+#include <rtems/dpmem.h>
+#include <rtems/object.h>
+#include <rtems/thread.h>
+
+/*PAGE
+ *
+ *  _Dual_ported_memory_Manager_initialization
+ *
+ *  This routine initializes all dual-ported memory manager related
+ *  data structures.
+ *
+ *  Input parameters:
+ *    maximum_ports - number of ports to initialize
+ *
+ *  Output parameters:  NONE
+ */
+
+void _Dual_ported_memory_Manager_initialization(
+  unsigned32 maximum_ports
+)
+{
+  _Objects_Initialize_information(
+     &_Dual_ported_memory_Information,
+     FALSE,
+     maximum_ports,
+     sizeof( Dual_ported_memory_Control )
+  );
+}
+
+/*PAGE
+ *
+ *  rtems_port_create
+ *
+ *  This directive creates a port into a dual-ported memory area.
+ *
+ *  Input parameters:
+ *    name           - user defined port name
+ *    internal_start - internal start address of port
+ *    external_start - external start address of port
+ *    length         - physical length in bytes
+ *    id             - address of port id to set
+ *
+ *  Output parameters:
+ *    id       - port id
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code - if unsuccessful
+ */
+
+rtems_status_code rtems_port_create(
+  Objects_Name  name,
+  void         *internal_start,
+  void         *external_start,
+  unsigned32    length,
+  Objects_Id   *id
+)
+{
+  register Dual_ported_memory_Control *the_port;
+
+  if ( !_Objects_Is_name_valid( name) )
+    return ( RTEMS_INVALID_NAME );
+
+  if ( !_Addresses_Is_aligned( internal_start ) ||
+       !_Addresses_Is_aligned( external_start ) )
+    return( RTEMS_INVALID_ADDRESS );
+
+  _Thread_Disable_dispatch();             /* to prevent deletion */
+
+  the_port = _Dual_ported_memory_Allocate();
+
+  if ( !the_port ) {
+    _Thread_Enable_dispatch();
+    return( RTEMS_TOO_MANY );
+  }
+
+  the_port->internal_base = internal_start;
+  the_port->external_base = external_start;
+  the_port->length        = length - 1;
+
+  _Objects_Open( &_Dual_ported_memory_Information,
+                 &the_port->Object, name );
+  *id = the_port->Object.id;
+  _Thread_Enable_dispatch();
+  return( RTEMS_SUCCESSFUL );
+}
+
+/*PAGE
+ *
+ *  rtems_port_ident
+ *
+ *  This directive returns the system ID associated with
+ *  the port name.
+ *
+ *  Input parameters:
+ *    name - user defined port name
+ *    id   - pointer to port id
+ *
+ *  Output parameters:
+ *    *id      - port id
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code - if unsuccessful
+ */
+
+rtems_status_code rtems_port_ident(
+  Objects_Name  name,
+  Objects_Id   *id
+)
+{
+  return(
+    _Objects_Name_to_id(
+      &_Dual_ported_memory_Information,
+      name,
+      RTEMS_SEARCH_ALL_NODES,
+      id
+    )
+  );
+}
+
+/*PAGE
+ *
+ *  rtems_port_delete
+ *
+ *  This directive allows a thread to delete a dual-ported memory area
+ *  specified by the dual-ported memory identifier.
+ *
+ *  Input parameters:
+ *    id - dual-ported memory area id
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code        - if unsuccessful
+ */
+
+rtems_status_code rtems_port_delete(
+  Objects_Id id
+)
+{
+  register Dual_ported_memory_Control *the_port;
+  Objects_Locations                    location;
+
+  the_port = _Dual_ported_memory_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:        /* this error cannot be returned */
+      return( RTEMS_INTERNAL_ERROR );
+    case OBJECTS_LOCAL:
+      _Objects_Close( &_Dual_ported_memory_Information, &the_port->Object );
+      _Dual_ported_memory_Free( the_port );
+      _Thread_Enable_dispatch();
+      return( RTEMS_SUCCESSFUL );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
+
+/*PAGE
+ *
+ *  rtems_port_internal_to_external
+ *
+ *  This directive converts an internal dual-ported memory address to an
+ *  external dual-ported memory address.  If the given internal address
+ *  is an invalid dual-ported address, then the external address is set
+ *  to the given internal address.
+ *
+ *  Input parameters:
+ *    id       - id of dual-ported memory object
+ *    internal - internal address to set
+ *    external - pointer to external address
+ *
+ *  Output parameters:
+ *    external          - external address
+ *    RTEMS_SUCCESSFUL - always succeeds
+ */
+
+rtems_status_code rtems_port_internal_to_external(
+  Objects_Id   id,
+  void        *internal,
+  void       **external
+)
+{
+  register Dual_ported_memory_Control *the_port;
+  Objects_Locations                    location;
+  unsigned32                           ending;
+
+  the_port = _Dual_ported_memory_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:        /* this error cannot be returned */
+      return( RTEMS_INTERNAL_ERROR );
+    case OBJECTS_LOCAL:
+      ending = _Addresses_Subtract( internal, the_port->internal_base );
+      if ( ending > the_port->length )
+        *external = internal;
+      else
+        *external = _Addresses_Add_offset( the_port->external_base,
+                                           ending );
+      _Thread_Enable_dispatch();
+      return( RTEMS_SUCCESSFUL );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
+
+/*PAGE
+ *
+ *  rtems_port_external_to_internal
+ *
+ *  This directive converts an external dual-ported memory address to an
+ *  internal dual-ported memory address.  If the given external address
+ *  is an invalid dual-ported address, then the internal address is set
+ *  to the given external address.
+ *
+ *  Input parameters:
+ *    id       - id of dp memory object
+ *    external - external address
+ *    internal - pointer of internal address to set
+ *
+ *  Output parameters:
+ *    internal          - internal address
+ *    RTEMS_SUCCESSFUL - always succeeds
+ */
+
+rtems_status_code rtems_port_external_to_internal(
+  Objects_Id   id,
+  void        *external,
+  void       **internal
+)
+{
+  register Dual_ported_memory_Control *the_port;
+  Objects_Locations                    location;
+  unsigned32                           ending;
+
+  the_port = _Dual_ported_memory_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:        /* this error cannot be returned */
+      return( RTEMS_INTERNAL_ERROR );
+    case OBJECTS_LOCAL:
+      ending = _Addresses_Subtract( external, the_port->external_base );
+      if ( ending > the_port->length )
+        *internal = external;
+      else
+        *internal = _Addresses_Add_offset( the_port->internal_base,
+                                           ending );
+      _Thread_Enable_dispatch();
+      return( RTEMS_SUCCESSFUL );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
Index: cpukit/rtems/src/event.c
===================================================================
--- cpukit/rtems/src/event.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
+++ cpukit/rtems/src/event.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -0,0 +1,294 @@
+/*
+ *  Event Manager
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/event.h>
+#include <rtems/isr.h>
+#include <rtems/object.h>
+#include <rtems/options.h>
+#include <rtems/states.h>
+#include <rtems/thread.h>
+
+/*PAGE
+ *
+ *  rtems_event_send
+ *
+ *  This directive allows a thread send an event set to another thread.
+ *
+ *  Input parameters:
+ *    id    - thread id
+ *    event - event set
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code - if unsuccessful
+ */
+
+rtems_status_code rtems_event_send(
+  Objects_Id         id,
+  rtems_event_set event_in
+)
+{
+  register Thread_Control *the_thread;
+  Objects_Locations        location;
+
+  the_thread = _Thread_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:
+      return(
+        _Event_MP_Send_request_packet(
+          EVENT_MP_SEND_REQUEST,
+          id,
+          event_in
+        )
+      );
+    case OBJECTS_LOCAL:
+      _Event_sets_Post( event_in, &the_thread->pending_events );
+      _Event_Surrender( the_thread );
+      _Thread_Enable_dispatch();
+      return( RTEMS_SUCCESSFUL );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
+
+/*PAGE
+ *
+ *  rtems_event_receive
+ *
+ *  This directive allows a thread to receive a set of events.
+ *
+ *  Input parameters:
+ *    event_in   - input event condition
+ *    option_set - options
+ *    ticks      - number of ticks to wait (0 means wait forever)
+ *    event_out  - pointer to output event set
+ *
+ *  Output parameters:
+ *    event out         - event set
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code        - if unsuccessful
+ */
+
+rtems_status_code rtems_event_receive(
+  rtems_event_set  event_in,
+  rtems_option     option_set,
+  rtems_interval   ticks,
+  rtems_event_set *event_out
+)
+{
+  if ( _Event_sets_Is_empty( event_in ) ) {
+    *event_out = _Thread_Executing->pending_events;
+    return( RTEMS_SUCCESSFUL );
+  }
+
+  _Thread_Disable_dispatch();
+  _Event_Seize( event_in, option_set, ticks );
+  _Thread_Enable_dispatch();
+  *event_out = _Thread_Executing->events_out;
+  return( _Thread_Executing->Wait.return_code );
+}
+
+/*PAGE
+ *
+ *  _Event_Seize
+ *
+ *  This routine attempts to satisfy the requested event condition
+ *  for the running thread.
+ *
+ *  Input parameters:
+ *    event_in   - the event condition to satisfy
+ *    option_set - acquire event options
+ *    ticks      - interval to wait
+ *
+ *  Output parameters: NONE
+ *
+ *  INTERRUPT LATENCY:
+ *    available
+ *    wait
+ *    check sync
+ */
+
+void _Event_Seize(
+  rtems_event_set event_in,
+  rtems_option    option_set,
+  rtems_interval  ticks
+)
+{
+  Thread_Control   *executing;
+  rtems_event_set   seized_events;
+  rtems_event_set   pending_events;
+  ISR_Level         level;
+
+  executing = _Thread_Executing;
+  executing->Wait.return_code = RTEMS_SUCCESSFUL;
+
+  _ISR_Disable( level );
+  pending_events = executing->pending_events;
+  seized_events  = _Event_sets_Get( pending_events, event_in );
+
+  if ( !_Event_sets_Is_empty( seized_events ) &&
+       (seized_events == event_in || _Options_Is_any( option_set )) ) {
+    executing->pending_events =
+      _Event_sets_Clear( pending_events, seized_events );
+    _ISR_Enable( level );
+    executing->events_out = seized_events;
+    return;
+  }
+
+  if ( _Options_Is_no_wait( option_set ) ) {
+    _ISR_Enable( level );
+    executing->Wait.return_code = RTEMS_UNSATISFIED;
+    executing->events_out = seized_events;
+    return;
+  }
+
+  _Event_Sync = TRUE;
+  executing->Wait.option_set            = option_set;
+  executing->Wait.Extra.event_condition = event_in;
+
+  _ISR_Enable( level );
+  _Thread_Set_state( executing, STATES_WAITING_FOR_EVENT );
+
+  if ( ticks ) {
+    _Watchdog_Initialize(
+      &executing->Timer,
+      _Event_Timeout,
+      executing->Object.id,
+      NULL
+    );
+    _Watchdog_Insert_ticks(
+      &executing->Timer,
+      ticks,
+      WATCHDOG_NO_ACTIVATE
+    );
+  }
+
+  _ISR_Disable( level );
+  if ( _Event_Sync == TRUE ) {
+    _Event_Sync = FALSE;
+    if ( ticks )
+      _Watchdog_Activate( &executing->Timer );
+    _ISR_Enable( level );
+    return;
+  }
+  _ISR_Enable( level );
+  (void) _Watchdog_Remove( &executing->Timer );
+  _Thread_Unblock( executing );
+  return;
+}
+
+/*PAGE
+ *
+ *  _Event_Surrender
+ *
+ *  This routines remove a thread from the specified threadq.
+ *
+ *  Input parameters:
+ *    the_thread - pointer to thread to be dequeued
+ *
+ *  Output parameters: NONE
+ *
+ *  INTERRUPT LATENCY:
+ *    before flash
+ *    after flash
+ *    check sync
+ */
+
+void _Event_Surrender(
+  Thread_Control *the_thread
+)
+{
+  ISR_Level          level;
+  rtems_event_set pending_events;
+  rtems_event_set event_condition;
+  rtems_event_set seized_events;
+
+  _ISR_Disable( level );
+  pending_events  = the_thread->pending_events;
+  event_condition = the_thread->Wait.Extra.event_condition;
+
+  seized_events = _Event_sets_Get( pending_events, event_condition );
+
+  if ( !_Event_sets_Is_empty( seized_events ) ) {
+    if ( _States_Is_waiting_for_event( the_thread->current_state ) ) {
+      if ( seized_events == event_condition ||
+                    _Options_Is_any( the_thread->Wait.option_set ) ) {
+        the_thread->pending_events =
+           _Event_sets_Clear( pending_events, seized_events );
+        (rtems_event_set *)the_thread->events_out = seized_events;
+
+        _ISR_Flash( level );
+
+        if ( !_Watchdog_Is_active( &the_thread->Timer ) ) {
+          _ISR_Enable( level );
+          _Thread_Unblock( the_thread );
+        }
+        else {
+          _Watchdog_Deactivate( &the_thread->Timer );
+          _ISR_Enable( level );
+          (void) _Watchdog_Remove( &the_thread->Timer );
+          _Thread_Unblock( the_thread );
+        }
+        return;
+      }
+    }
+    else if ( _Thread_Is_executing( the_thread ) && _Event_Sync == TRUE ) {
+      if ( seized_events == event_condition ||
+                    _Options_Is_any( the_thread->Wait.option_set ) ) {
+        the_thread->pending_events =
+           _Event_sets_Clear( pending_events,seized_events );
+        (rtems_event_set *)the_thread->events_out = seized_events;
+        _Event_Sync = FALSE;
+      }
+    }
+  }
+  _ISR_Enable( level );
+}
+
+/*PAGE
+ *
+ *  _Event_Timeout
+ *
+ *  This routine processes a thread which timeouts while waiting to
+ *  receive an event_set. It is called by the watchdog handler.
+ *
+ *  Input parameters:
+ *    id - thread id
+ *
+ *  Output parameters: NONE
+ */
+
+void _Event_Timeout(
+  Objects_Id  id,
+  void       *ignored
+)
+{
+  Thread_Control *the_thread;
+  Objects_Locations      location;
+
+  the_thread = _Thread_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+    case OBJECTS_REMOTE:  /* impossible */
+      break;
+    case OBJECTS_LOCAL:
+      the_thread->Wait.return_code = RTEMS_TIMEOUT;
+      _Thread_Unblock( the_thread );
+      _Thread_Unnest_dispatch();
+      break;
+  }
+}
Index: cpukit/rtems/src/eventmp.c
===================================================================
--- cpukit/rtems/src/eventmp.c	(revision 17f744b8c81be98f68d53a82583c9a0b1c690579)
+++ cpukit/rtems/src/eventmp.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -1,110 +1,87 @@
-/* SPDX-License-Identifier: BSD-2-Clause */
-
-/**
- * @file
+/*
+ *  Multiprocessing Support for the Event Manager
  *
- * @ingroup RTEMSImplClassicEventMP
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
  *
- * @brief This source file contains the implementation to support the Event
- *   Manager in multiprocessing (MP) configurations.
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
  */
 
-/*
- *  COPYRIGHT (c) 1989-2008.
- *  On-Line Applications Research Corporation (OAR).
+#include <rtems/system.h>
+#include <rtems/event.h>
+#include <rtems/mpci.h>
+#include <rtems/mppkt.h>
+#include <rtems/object.h>
+#include <rtems/options.h>
+#include <rtems/states.h>
+#include <rtems/thread.h>
+
+/*PAGE
  *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
+ *  _Event_MP_Send_process_packet
  *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
+ *  This subprogram is not needed since there are no process
+ *  packets to be sent by this manager.
+ *
  */
 
-#ifdef HAVE_CONFIG_H
-#include "config.h"
-#endif
+/*PAGE
+ *
+ *  _Event_MP_Send_request_packet
+ *
+ */
 
-#include <rtems/rtems/eventimpl.h>
-#include <rtems/rtems/statusimpl.h>
-#include <rtems/score/threadimpl.h>
-#include <rtems/score/statesimpl.h>
-
-/**
- *  The following enumerated type defines the list of
- *  remote event operations.
- */
-typedef enum {
-  EVENT_MP_SEND_REQUEST  =  0,
-  EVENT_MP_SEND_RESPONSE =  1
-}   Event_MP_Remote_operations;
-
-/**
- *  The following data structure defines the packet used to perform
- *  remote event operations.
- */
-typedef struct {
-  rtems_packet_prefix         Prefix;
-  Event_MP_Remote_operations  operation;
-  rtems_event_set             event_in;
-}   Event_MP_Packet;
-
-RTEMS_STATIC_ASSERT(
-  sizeof(Event_MP_Packet) <= MP_PACKET_MINIMUM_PACKET_SIZE,
-  Event_MP_Packet
-);
-
-static Event_MP_Packet *_Event_MP_Get_packet( Objects_Id id )
-{
-  if ( !_Thread_MP_Is_remote( id ) ) {
-    return NULL;
-  }
-
-  return (Event_MP_Packet *) _MPCI_Get_packet();
-}
-
-rtems_status_code _Event_MP_Send(
-  rtems_id        id,
-  rtems_event_set event_in
+rtems_status_code _Event_MP_Send_request_packet (
+  Event_MP_Remote_operations operation,
+  Objects_Id                 event_id,
+  rtems_event_set         event_in
 )
 {
   Event_MP_Packet *the_packet;
-  Status_Control   status;
 
-  the_packet = _Event_MP_Get_packet( id );
-  if ( the_packet == NULL ) {
-    return RTEMS_INVALID_ID;
+  switch ( operation ) {
+
+    case EVENT_MP_SEND_REQUEST:
+
+      the_packet                    = _Event_MP_Get_packet();
+      the_packet->Prefix.the_class  = RTEMS_MP_PACKET_EVENT;
+      the_packet->Prefix.length     = sizeof ( Event_MP_Packet );
+      the_packet->Prefix.to_convert = sizeof ( Event_MP_Packet );
+      the_packet->operation         = operation;
+      the_packet->Prefix.id         = event_id;
+      the_packet->event_in          = event_in;
+
+      return
+        _MPCI_Send_request_packet(
+          rtems_get_node( event_id ),
+          &the_packet->Prefix,
+          STATES_READY
+        );
+
+      break;
+
+    case EVENT_MP_SEND_RESPONSE:
+      break;
+
   }
-
-  the_packet->Prefix.the_class  = MP_PACKET_EVENT;
-  the_packet->Prefix.length     = sizeof ( *the_packet );
-  the_packet->Prefix.to_convert = sizeof ( *the_packet );
-  the_packet->operation         = EVENT_MP_SEND_REQUEST;
-  the_packet->Prefix.id         = id;
-  the_packet->event_in          = event_in;
-
-  status = _MPCI_Send_request_packet(
-    _Objects_Get_node( id ),
-    &the_packet->Prefix,
-    STATES_READY
-  );
-  return _Status_Get( status );
+  /*
+   *  The following line is included to satisfy compilers which
+   *  produce warnings when a function does not end with a return.
+   */
+  return RTEMS_SUCCESSFUL;
 }
 
-static void _Event_MP_Send_response_packet (
+/*PAGE
+ *
+ *  _Event_MP_Send_response_packet
+ *
+ */
+
+void _Event_MP_Send_response_packet (
   Event_MP_Remote_operations  operation,
   Thread_Control             *the_thread
@@ -127,5 +104,5 @@
 
       _MPCI_Send_response_packet(
-        _Objects_Get_node( the_packet->Prefix.source_tid ),
+        rtems_get_node( the_packet->Prefix.source_tid ),
         &the_packet->Prefix
       );
@@ -138,4 +115,11 @@
 }
 
+/*PAGE
+ *
+ *
+ *  _Event_MP_Process_packet
+ *
+ */
+
 void _Event_MP_Process_packet (
   rtems_packet_prefix  *the_packet_prefix
@@ -143,4 +127,5 @@
 {
   Event_MP_Packet *the_packet;
+  Thread_Control  *the_thread;
 
   the_packet = (Event_MP_Packet *) the_packet_prefix;
@@ -161,15 +146,17 @@
       break;
 
-    case EVENT_MP_SEND_RESPONSE: {
-      _MPCI_Process_response( the_packet_prefix );
+    case EVENT_MP_SEND_RESPONSE:
+
+      the_thread = _MPCI_Process_response( the_packet_prefix );
+
       _MPCI_Return_packet( the_packet_prefix );
 
       break;
-    }
 
   }
 }
 
-/*
+/*PAGE
+ *
  *  _Event_MP_Send_object_was_deleted
  *
@@ -179,5 +166,6 @@
  */
 
-/*
+/*PAGE
+ *
  *  _Event_MP_Send_extract_proxy
  *
@@ -187,3 +175,14 @@
  */
 
+/*PAGE
+ *
+ *  _Event_MP_Get_packet
+ *
+ */
+
+Event_MP_Packet *_Event_MP_Get_packet ( void )
+{
+  return ( (Event_MP_Packet *) _MPCI_Get_packet() );
+}
+
 /* end of file */
Index: cpukit/rtems/src/intr.c
===================================================================
--- cpukit/rtems/src/intr.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
+++ cpukit/rtems/src/intr.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -0,0 +1,85 @@
+/*
+ *  Interrupt Manager
+ *
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/isr.h>
+#include <rtems/stack.h>
+#include <rtems/intr.h>
+#include <rtems/wkspace.h>
+
+/*  _Interrupt_Manager_initialization
+ *
+ *  This routine initializes the interrupt manager.
+ *
+ *  Input parameters: NONE
+ *
+ *  Output parameters: NONE
+ */
+
+void _Interrupt_Manager_initialization( void )
+{
+#if ( CPU_ALLOCATE_INTERRUPT_STACK == TRUE )
+
+  if ( _CPU_Table.interrupt_stack_size < RTEMS_MINIMUM_STACK_SIZE )
+    rtems_fatal_error_occurred( RTEMS_INVALID_SIZE );
+
+  _CPU_Interrupt_stack_low =
+    _Workspace_Allocate_or_fatal_error( _CPU_Table.interrupt_stack_size );
+
+  _CPU_Interrupt_stack_high = _Addresses_Add_offset(
+    _CPU_Interrupt_stack_low,
+    _CPU_Table.interrupt_stack_size
+  );
+
+#endif
+
+#if ( CPU_HAS_HARDWARE_INTERRUPT_STACK == TRUE )
+  _CPU_Install_interrupt_stack();
+#endif
+
+}
+
+/*  rtems_interrupt_catch
+ *
+ *  This directive allows a thread to specify what action to take when
+ *  catching signals.
+ *
+ *  Input parameters:
+ *    new_isr_handler - address of interrupt service routine (isr)
+ *    vector          - interrupt vector number
+ *    old_isr_handler - address at which to store previous ISR address
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - always succeeds
+ *    *old_isr_handler  - previous ISR address
+ */
+
+rtems_status_code rtems_interrupt_catch(
+  rtems_isr_entry      new_isr_handler,
+  rtems_vector_number  vector,
+  rtems_isr_entry     *old_isr_handler
+)
+{
+  if ( !_ISR_Is_vector_number_valid( vector ) )
+    return( RTEMS_INVALID_NUMBER );
+
+  if ( !_ISR_Is_valid_user_handler( new_isr_handler ) )
+    return( RTEMS_INVALID_ADDRESS );
+
+  _ISR_Install_vector(
+    vector, (proc_ptr)new_isr_handler, (proc_ptr *)old_isr_handler );
+
+  return( RTEMS_SUCCESSFUL );
+}
Index: cpukit/rtems/src/mp.c
===================================================================
--- cpukit/rtems/src/mp.c	(revision 17f744b8c81be98f68d53a82583c9a0b1c690579)
+++ cpukit/rtems/src/mp.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -1,49 +1,127 @@
-/* SPDX-License-Identifier: BSD-2-Clause */
-
-/**
- * @file
+/*
+ *  Multiprocessing Manager
  *
- * @ingroup RTEMSImplClassic
  *
- * @brief This source file contains the implementation to support the Classic
- *   API in multiprocessing (MP) configurations.
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
  */
 
-/*
- *  COPYRIGHT (c) 1989-1999.
- *  On-Line Applications Research Corporation (OAR).
+#include <rtems/system.h>
+#include <rtems/config.h>
+#include <rtems/cpu.h>
+#include <rtems/event.h>
+#include <rtems/fatal.h>
+#include <rtems/intthrd.h>
+#include <rtems/message.h>
+#include <rtems/mp.h>
+#include <rtems/mpci.h>
+#include <rtems/mppkt.h>
+#include <rtems/part.h>
+#include <rtems/sem.h>
+#include <rtems/signal.h>
+#include <rtems/states.h>
+#include <rtems/tasks.h>
+#include <rtems/thread.h>
+#include <rtems/threadq.h>
+#include <rtems/watchdog.h>
+
+/*PAGE
  *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
+ *  _Multiprocessing_Manager_initialization
  *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
  */
 
-#ifdef HAVE_CONFIG_H
-#include "config.h"
-#endif
+void _Multiprocessing_Manager_initialization ( void )
+{
+  if ( _Configuration_MP_table->node < 1 ||
+       _Configuration_MP_table->node > _Configuration_MP_table->maximum_nodes )
+     rtems_fatal_error_occurred( RTEMS_INVALID_NODE );
 
-#include <rtems/rtems/mp.h>
-#include <rtems/score/mpciimpl.h>
+  _Internal_threads_Set_MP_receive_server( _Multiprocessing_Receive_server );
+}
+
+/*PAGE
+ *
+ *  rtems_multiprocessing_announce
+ *
+ */
 
 void rtems_multiprocessing_announce ( void )
 {
-  _MPCI_Announce();
+  _Thread_MP_Ready();
+}
+
+/*PAGE
+ *
+ *  _Multiprocessing_Receive_server
+ *
+ */
+
+Thread _Multiprocessing_Receive_server (
+  Thread_Argument ignored
+)
+{
+
+  rtems_packet_prefix *the_packet;
+
+  _Thread_Dispatch_disable_level = 1;
+
+  for ( ; ; ) {
+
+    _Internal_threads_System_initialization_thread->Notepads[ 0 ] = 1;
+
+    the_packet = _MPCI_Receive_packet();
+
+    if ( ! the_packet ) {
+      _Thread_MP_Block();
+      _Thread_Dispatch_disable_level = 1;
+    }
+    else {
+
+      _Thread_Executing->receive_packet = the_packet;
+
+      switch ( the_packet->the_class ) {
+
+        case RTEMS_MP_PACKET_INTERNAL_THREADS:
+          _Internal_threads_MP_Process_packet( the_packet );
+          break;
+
+        case RTEMS_MP_PACKET_TASKS:
+          _RTEMS_tasks_MP_Process_packet( the_packet );
+          break;
+
+        case RTEMS_MP_PACKET_MESSAGE_QUEUE:
+          _Message_queue_MP_Process_packet( the_packet );
+          break;
+
+        case RTEMS_MP_PACKET_SEMAPHORE:
+          _Semaphore_MP_Process_packet( the_packet );
+          break;
+
+        case RTEMS_MP_PACKET_PARTITION:
+          _Partition_MP_Process_packet( the_packet );
+          break;
+
+        case RTEMS_MP_PACKET_REGION:
+          /* Global regions are unsupported at this time */
+          break;
+
+        case RTEMS_MP_PACKET_EVENT:
+          _Event_MP_Process_packet( the_packet );
+          break;
+
+        case RTEMS_MP_PACKET_SIGNAL:
+          _Signal_MP_Process_packet( the_packet );
+          break;
+      }
+    }
+  }
 }
 
